﻿using UnityEngine;
using System.Collections;

public class AsunanPointer : PointerBase {

	public Texture				texture_body = null;		// テクスチャー　本体.
	public Texture				texture_fork = null;		// テクスチャー　フォークの先.
	public Texture				texture_bar  = null;		// テクスチャー　フォークの柄.

	protected Sprite2DControl	sprite_body = null;
	protected Sprite2DControl	sprite_fork = null;
	protected Sprite2DControl	sprite_bar  = null;

	// ================================================================ //
	// MonoBehaviour からの継承.

	// Use this for initialization
	void 	Start()
	{
	}
	
	// Update is called once per frame
	void 	Update()
	{
	}

	// ================================================================ //

	public override void	create()
	{
		// 本体.

		this.sprite_body = Sprite2DRoot.get().createSprite(this.texture_body, 2, true);
		this.sprite_body.setSize(Vector2.one*128.0f);
		this.sprite_body.setDepth(DEPTH);

		Vector2	screen_size = SlidePlayer.get().getScreenSize();

		this.sprite_body.setPosition(new Vector2(screen_size.x/2.0f - 100.0f, -(screen_size.y/2.0f - 100.0f)));

		// フォークの先.

		this.sprite_fork = Sprite2DRoot.get().createSprite(this.texture_fork, 2, true);
		this.sprite_fork.setSize(Vector2.one*80.0f);
		this.sprite_fork.setDepth(DEPTH);

		// フォークの柄.

		this.sprite_bar = Sprite2DRoot.get().createSprite(this.texture_bar, 2, true);
		this.sprite_bar.setSize(Vector2.one*80.0f);
		this.sprite_bar.setDepth(DEPTH);
	}

	public override void	setPosition(Vector2 position)
	{
		Vector2		body_position = this.sprite_body.getPosition();

		body_position.x -= this.sprite_body.getSize().x*0.4f;
		body_position.y -= this.sprite_body.getSize().y*0.1f;

		Vector2		bar_position = (position + body_position)/2.0f;

		Vector2		bar_vector = position - body_position;

		float		angle = Mathf.Atan2(bar_vector.y, bar_vector.x)*Mathf.Rad2Deg;

		this.sprite_bar.setAngle(angle);
		this.sprite_bar.setScale(new Vector2(bar_vector.magnitude/this.sprite_bar.getSize().x, 1.0f));
		this.sprite_bar.setPosition(bar_position);

		if(bar_vector.magnitude > 0.0f) {

			position -= bar_vector.normalized*this.sprite_fork.getSize().x/2.0f;
		}

		this.sprite_fork.setPosition(position);

		this.sprite_fork.setAngle(angle);
	}

	public override void	setVisible(bool is_visible)
	{
		base.setVisible(is_visible);

		this.sprite_body.setVisible(this.is_visible);
		this.sprite_bar.setVisible(this.is_visible);
		this.sprite_fork.setVisible(this.is_visible);
	}
}
